#############################################
# led_matrix_pfeile.py
#
# Auf einer LED-Matrix
# werden Pfeile dargestellt.
#
# Michael Weigend
# Raspberry Pi für Kids
# mitp 2015
# Kap. 12, Projekt 33
# 1. 11. 2014
#############################################

import os, time
from RPi import GPIO


GPIO.setmode(GPIO.BOARD)
s=[19,16, 15, 13]
z=[8, 10, 11, 12]

for pin in z + s:
    GPIO.setup(pin, GPIO.OUT)

LINKS =  [[0, 0, 0, 1],
          [1, 0, 1, 0],
          [1, 1, 0, 0],
          [1, 1, 1, 0]]

RECHTS = [[1, 0, 0, 0],
          [0, 1, 0, 1],
          [0, 0, 1, 1],
          [0, 1, 1, 1]]

KREUZ =  [[1, 0, 0, 1],
          [0, 1, 1, 0],
          [0, 1, 1, 0],
          [1, 0, 0,1]]

zeichen = {'L':LINKS, 'R':RECHTS, 'X':KREUZ}

for pin in z:
    GPIO.output(pin, True)  # alle Zeilen positiv

for pin in s:
    GPIO.output(pin, False)  # alle Spalten negativ

print('Bitte geben Sie R, L oder X ein')
a = input('Zeichen: ')
if a in 'RLX':
    muster = zeichen[a]
    while True:
        for i in range(4):
            GPIO.output(z[i], False)
            for j in range(4):        
                GPIO.output(s[j], muster[i][j])
            time.sleep(0.001)
            for j in range(4):
                GPIO.output(s[j], False)
            GPIO.output(z[i], True)


