#---------------------------------------------
# lcd_stoppuhr.py
# Stoppuhr. Schreibt die Uhrzeit auf ein 2x16-LCD-Display
# Hinweis: Python 2. Mit Root-Rechten starten.
#
# Michael Weigend
# Raspberry Pi fuer Kids
# Kapitel 13, Projekt 36
# 7.8.2014
#----------------------------------------------

import time
from RPLCD import CharLCD
from RPi import GPIO
GPIO.setmode(GPIO.BOARD)
GPIO.setup(3, GPIO.IN)
lcd=CharLCD(cols=16, rows=2)

while True:
    time.sleep(0.1)
    lcd.clear()
    lcd.write_string('0.00000000')
    lcd.cursor_pos =(1, 0)
    lcd.write_string('Start mit Knopf')
    while GPIO.input(3):
        pass
    while not GPIO.input(3):
        pass
    start = time.time()
    lcd.cursor_pos =(1, 0)
    lcd.write_string('Stopp mit Knopf')
    time.sleep(0.1)
    while GPIO.input(3):
        lcd.cursor_pos =(0, 0)
        zeit = time.time() - start
        lcd.write_string(str(zeit)[:10])
    while not GPIO.input(3):
        pass
    lcd.cursor_pos =(1, 0)
    lcd.write_string('Reset mit Knopf')
    time.sleep(0.1)
    while GPIO.input(3):
        pass
    while not GPIO.input(3):
        pass


