#---------------------------------------------
# abstand.py
# Das Programm druckt jede Sekunde den aktuellen Abstand
# zu einem Hindernis vor dem Ultraschallsensor.
#
# Michael Weigend
# Raspberry Pi fuer Kids
# Kapitel 14, Projekt 38
# 1.11.2014
#----------------------------------------------
import time
from RPi import GPIO
TRIGGER = 8                                     #1
ECHO = 10

def init_gpio():
    '''Initialisiert die Schnittstelle zum GPIO'''
    GPIO.setwarnings(False)                     #2
    GPIO.setmode(GPIO.BOARD)
    GPIO.setup(TRIGGER, GPIO.OUT)
    GPIO.setup(ECHO, GPIO.IN)
    GPIO.output(TRIGGER, False)                  
    time.sleep(1)                               #3

def sende_impuls():
    '''Sendet Impuls der Länge 10 Mikrosekunden'''
    GPIO.output(TRIGGER, True)                  #4
    time.sleep(0.00001)                         #5
    GPIO.output(TRIGGER, False)

def empfange_echo():
    '''Liefert Länge des Echo-Signals ''' 
    while GPIO.input(ECHO)== 0:                 #6
        pass
    start = time.time()
    while GPIO.input(ECHO)== 1:                 #7
        pass
    stop = time.time()
    return stop - start

def berechne_abstand():
    '''Liefert Abstand in cm '''
    sende_impuls()
    zeit = empfange_echo()
    abstand = (zeit * 34000)/2                  #8
    return round(abstand)
    
# Hauptprogramm
init_gpio()
while True:                                     #9
    a = berechne_abstand()
    print('Abstand:', a, 'cm')                 #10
    time.sleep(1)
