#---------------------------------------------
# abstand_timeout.py
# Das Programm druckt jede Sekunde den aktuellen Abstand
# zu einem Hindernis vor dem Ultraschallsensor. Verbesserte
# Version mit Timeout.
#
# Michael Weigend
# Raspberry Pi fuer Kids
# Kapitel 14, Projekt 38
# 1.11.2014
#----------------------------------------------

import time
from RPi import GPIO
TRIGGER = 8
ECHO = 10
TIMEOUT = 0.1

def init_gpio():
    '''Initialisiert die Schnittstelle zum GPIO'''
    GPIO.setwarnings(False)
    GPIO.setmode(GPIO.BOARD)
    GPIO.setup(TRIGGER, GPIO.OUT)
    GPIO.setup(ECHO, GPIO.IN)
    GPIO.output(TRIGGER, False)
    time.sleep(1)

def sende_impuls():
    '''Sendet Impuls der Länge 10 Mikrosekunden'''
    GPIO.output(TRIGGER, True)
    time.sleep(0.00001)
    GPIO.output(TRIGGER, False)

def empfange_echo():
    '''Liefert Länge des Echo-Signals des Sensors
       Falls die Messung gescheitert ist,
       wird 0 zurückgegeben '''
    nullzeit = time.time()
    while GPIO.input(ECHO)== 0:
        if time.time() > nullzeit + TIMEOUT:
            return 0      
    start = time.time()
    while GPIO.input(ECHO)== 1:
        pass
    stop = time.time()
    return stop - start

def berechne_abstand():
    '''Liefert Abstand in cm'''
    sende_impuls()
    zeit = empfange_echo()
    abstand = (zeit * 34000)/2
    return round(abstand)
    
# Hauptprogramm
init_gpio()

while True:
    a = berechne_abstand()
    if a > 0:
        print(i, 'Abstand:', a, 'cm')
    time.sleep(1)
    
          
