#---------------------------------------------
# suche_heiss.py
# Suche die heißeste Stelle im Raum.
#
# Michael Weigend
# Raspberry Pi für Kids
# mitp 2015
# Kapitel 15, Aufgabe 1
# 1.11.2014
#---------------------------------------------
import os, time
from RPi import GPIO
SCHALTER = 3
LED = 10
DATEINAME = "/sys/bus/w1/devices/xxx/w1_slave"  #1

def init():
    os.system('modprobe wire')                     
    os.system('modprobe w1-gpio')
    os.system("modprobe w1-therm")
    GPIO.setmode(GPIO.BOARD)
    GPIO.setup(LED, GPIO.OUT)
    GPIO.setup(SCHALTER, GPIO.IN)

def blinken():                                  #2
    for i in range(3):
        GPIO.output(LED, True)
        time.sleep(0.3)
        GPIO.output(LED, False)
        time.sleep(0.3)      

def readTemp():
    ok = False                                 
    while not ok:
        f = open(DATEINAME, 'r')               
        zeile_1, zeile_2 = f.readlines()       
        f.close()                           
        if zeile_1.find("YES") != -1:          
            ok = True
    teil_1, teil_2 = zeile_2.split("=")        
    return int(teil_2)/1000                   

# Hauptprogramm
init()
blinken()                                       #3
alt = readTemp()                                #4
while GPIO.input(SCHALTER):
    neu = readTemp()                            #5
    if neu > alt:
        GPIO.output(LED, True)
    elif neu < alt:
        GPIO.output(LED, False)
    alt = neu
    time.sleep(0.5)                             #6

os.system('halt')                               #7                   
    
