#! /usr/bin/python2.7
#------------------------------------------------
# bewegung.py
# Wenn sich etwas bewegt, wird ein Foto aufgenommen
# und gespeichert
# Python 2.7
# Michael Weigend
# Raspberry Pi fuer Kids
# Kapitel 17, Projekt 49
# 24.8.2014
#------------------------------------------------

import os, time 
from PIL import Image, ImageDraw
                            
ORDNER = '/home/pi/python-projekte/kap17/garten/'   
KOMMANDO = 'raspistill -t 300 -w %i -h %i -n -o %s'
SCHWELLE = 40                                         
MIN = 20

def unterschied(bild1, bild2):                      
    unterschiedliche_pixel = 0
    b1 = bild1.load()
    b2 = bild2.load()                 
    breite, hoehe = altes_bild.size
    for x in range(breite):
        for y in range(hoehe):

            pixel1 = b1[x, y]
            pixel2 = b2[x, y]
            d = abs(pixel1[1] - pixel2[1])   
            if d > SCHWELLE:
                 unterschiedliche_pixel += 1
    return unterschiedliche_pixel 

# Hauptprogramm
os.system(KOMMANDO %(80, 60, ORDNER + 'bild.jpg'))
time.sleep(0.5)  
bild = Image.open(ORDNER + 'bild.jpg')
i = 0
while True:
  altes_bild = bild                    
  os.system(KOMMANDO %(80, 60,
                       ORDNER + 'bild.jpg'))
  bild = Image.open(ORDNER + 'bild.jpg')
  if unterschied(bild, altes_bild) > MIN:
    i += 1
    dateiname = 'bild_' + str(i) +'.jpg'
    os.system(KOMMANDO % (400, 300,
                          ORDNER + dateiname))
    foto = Image.open(ORDNER + dateiname)
    foto_mit_zeit = ImageDraw.Draw(foto)
    foto_mit_zeit.text((0, 0), time.asctime())
    foto.save(ORDNER + dateiname) 
    print('Bewegung erkannt', time.asctime())
    time.sleep(3)
        

    


    
