# -*- coding: utf-8 -*-
#------------------------------------------------
# farben_schloss.py
# Das Kameramodul ist angeschlossen.
# Vor der Kamera ist ein Blatt mit sechs farbigen Quadraten
# (schwarz, rot, gruen, blau). Das Programm
# erkennt das Farbmuster und entscheidet, ob es
# mit gespeicherten Farbmustern übereinstimmt.
#
# Michael Weigend
# Raspberry Pi fuer Kids
# Kapitel 17, Projekt 52
# 17.8.2014
#------------------------------------------------
import os, time
from Tkinter import Tk, Label, Button, Canvas, NW
from PIL import Image, ImageTk
BBOX = (200, 150, 600, 450)
PERSONEN = {'rgbbsr':'David',
            'rrbbsg':'Laura',
            'sgbrrb':'Fabian'}

def zeige_bild():
    global bild, foto
    kommando = 'raspistill -t 500 -w 800 -h 600 -o bild.jpg -n'
    os.system(kommando)
    bild = Image.open('bild.jpg').crop(BBOX)
    foto = ImageTk.PhotoImage(bild)   
    leinwand.create_image(0, 0, anchor=NW, image=foto)
    leinwand.create_rectangle(50, 50, 350, 250)
    fenster.after(500, zeige_bild)

def check():
    farben = farbe(100, 100) + farbe(200, 100) \
           + farbe(300, 100) + farbe(100, 200) \
           + farbe(200, 200) + farbe(300, 200) 
    if farben in PERSONEN.keys():
        text = farben + ' ------ Hallo, ' \
               + PERSONEN[farben] + '!'
    else:
        text = farben + ' ------ unbekannt'     
    label.config(text=text)

def farbe(x, y):
    r, g, b = bild.getpixel((x, y))
    print (r, g, b)
    if r > 0.95 * (g + b):
        return 'r'
    if g > 0.8 * (r + b):
        return 'g'
    if b > 0.7 * (r + g):
        return 'b'
    else:
        return 's'
    
fenster=Tk()
leinwand = Canvas(master=fenster,width=400, height=300)
leinwand.pack()
button = Button(master=fenster, command=check,
                text='Check')
button.pack()
label = Label(master=fenster, text='')
label.pack()
                
zeige_bild()
fenster.mainloop()
